#!/usr/bin/perl -w
#use strict;

##for local/server use, change path 
my $driverpath = '/users/sista/mclaeys/INCLUSive_for_users/';

## Date of last changes : 11 febr 2010

#script to move MS .txt and .mtrx files from MS-250_50_new/ to MS-250_50_new1/';

# perl command for this script :
#################################################### 
# perl move_250_MSfiles.pl $ARGV[0] 
####################################################
# $ARGV[i] = file with settings for different TF 

####################################################
# subroutines
#################################################### 
# &readsettings 
####################################################

# path
my $outputpath = '/users/sista/mclaeys/INCLUSive_tests/MS-250_50_new/';
my $outputpath1 = '/users/sista/mclaeys/INCLUSive_tests/MS-250_50_new1/';


# variables to be loaded from the settingsfile
my @data; #= ('LexA');
#my @space; # = ('coregulation/');
my @bgOrder; # = (0,1,2,3);
my $bmatrix; # = 1
my $btrack; # = 1;
my @nbrInstPrior; # = ('0.25_0.25','0.9_0.25', 'u', 'e0_1', 'e0_0_1', 'e0_0.45_0.3_0.25','f0_1');
my @search; # = (1); 
my $runs; # = 100;
my $repeats; #10

# removed/changed from settingsfile : 
my $width; #to be read from the specific inputfile wM.txt
my $nbrMotifs = 1; 
my $overlap = '-'; # not applicable 
#my @tfbscoord; #to be read from the specific inputfile
my $strand = 0;
my $maxInst; #to be read from the specific inputfile

# read the ARGV 
my $nbrfiles = $#ARGV;
my $settingsfile;
my $argnum;

# local variables
my $command;
my $fastafile; my $fastafile1;
my $wMfile;
my $outpudir;
my $outpudir1;
my $nbrBgOrders;
my $bgfile;
my $prior;
my $method;
my $outputdirsub;
my $outputdirsub1;
my @split;
my $outputfile;my $outputfile1;
my $matrixfile;my $matrixfile1;

# repeat for each file
foreach $argnum (0 .. $nbrfiles)
{
  # load the file
  $settingsfile = $ARGV[$argnum];
  if (!(-e $settingsfile))
  { print 'ERROR '.$settingsfile." : file not found - SKIP\n"; next;}
  print 'Processing '.$settingsfile."...\n"; 

  # update the parameters as read from the settingsfile
  &readsettings($settingsfile); 

  # repeat for each dataset(=regulator)
  for(my $d = 0; $d < scalar(@data); $d++)
  {
    
    # get the motifwidth and maxInst (the wM.txt file should be available)
    $wMfile = $outputpath.'RegulonDB/'.$data[$d].'_wM.txt';
    if (!(-e $wMfile))
    { print 'WARNING '.$wMfile." : wMfile not found - SKIP MotifSampler\n"; next;}
    &readsettings($wMfile);
    if ( $width == 0 || $maxInst == 0)
    { print 'WARNING '.$wMfile.' : wrong $width/$maxInst format - SKIP MotifSampler'."\n"; next;} 

    # get regulator subdirectory for output
    $outputdir = $outputpath.'output/'.$data[$d].'/';
    if (!(-e $outputdir))
    { next;} #skip 
    $outputdir1 = $outputpath1.'output/'.$data[$d].'/';
  
    # repeat for each backgroundfile
    $nbrBgOrders = scalar(@bgOrder);
    for(my $b = 0; $b < $nbrBgOrders; $b++)
    {

      #repeat for each nbrInstprior
      for(my $p = 0; $p < scalar(@nbrInstPrior); $p++)
      {
        $prior = $nbrInstPrior[$p];
        #repeat for each search method
        for(my $m = 0; $m < scalar(@search); $m++)
        {
          $method = $search[$m];
          # find the output-subdirectory
          $outputdirsub = $outputdir.'bg_'.$bgOrder[$b].'/prior_'.$prior.'/method_'.$method.'/';
          if (!(-e $outputdirsub))
          { next;} #skip 
          # create the new output-subdirectory
          $outputdirsub1 = $outputdir1.'bg_'.$bgOrder[$b].'/prior_'.$prior.'/method_'.$method.'/';
          if (!(-e $outputdirsub1))
          { $command = 'mkdir -p '.$outputdirsub1; system($command);} 

          # for $repeats times
          for(my $r=1; $r <= $repeats; $r++)
          {
            $outputfile = $outputdirsub.'w'.$width.'_n'.$nbrMotifs.'_s'.$strand.'_x'.$overlap.'_M'.$maxInst.'_r'.$r.'.txt';
            $matrixfile = $outputdirsub.'w'.$width.'_n'.$nbrMotifs.'_s'.$strand.'_x'.$overlap.'_M'.$maxInst.'_r'.$r.'.mtrx'; 
            $outputfile1 = $outputdirsub1.'w'.$width.'_n'.$nbrMotifs.'_s'.$strand.'_x'.$overlap.'_M'.$maxInst.'_r'.$r.'.txt';
            $matrixfile1 = $outputdirsub1.'w'.$width.'_n'.$nbrMotifs.'_s'.$strand.'_x'.$overlap.'_M'.$maxInst.'_r'.$r.'.mtrx'; 
            # copy the files
            if (-e $outputfile)
            { open(FOUT, ">$outputfile1");
              open(FIN, "<$outputfile");
              while(<FIN>) 
              {
                my $line = $_; 
                print FOUT $line;
              }
              close(FIN);
              close(FOUT);
              print 'COPY to '.$outputfile1."\n";
            }
            if (-e $matrixfile)
            { open(FOUT, ">$matrixfile1");
              open(FIN, "<$matrixfile");
              while(<FIN>) 
              {
                my $line = $_; 
                print FOUT $line;
              }
              close(FIN);
              close(FOUT);
              print 'COPY to '.$matrixfile1."\n";
            }
          }
        }
      }
    }
    print 'INFO @data['.$d.'] = '.$data[$d]." - FINISHED\n";
  }   
}
print 'INFO script finishes succesfully'."\n";

######################################## SUBROUTINES
######################################################################################
#loading variables from file into main
######################################################################################
sub readsettings 
{ 
  my ($file) = @_;
  open(FI, $file);
  while(<FI>) 
  {
    my $line = $_; 
    chomp $line;
    if ($line =~ m/^\$/ || $line =~ m/^\@/){ eval($line);}
  }
  close(FI);
}


