#!/usr/bin/perl -w
#use strict;

##for local/server use, change path 
#my $driverpath = '/home/marleen/';
my $driverpath = '/users/sista/mclaeys/INCLUSive_for_users/';
## inclusive version 
$driverpath .= 'INCLUSive-5.0.5/';
my $command;


# script to run FC-5.0.5 on data 250_50_new ! runs on files in "output1" folder !!
# output goes to the output-directory where the inputfiles are available

## Date  : 11 nov 2010

# perl command for this script :
#################################################### 
# perl runFC-250_50_new.pl $ARGV[0]
####################################################
# $ARGV[0] = refer to settingsfile from runMS-3.1.5 ->route to dir of outputfiles

####################################################
# subroutines
#################################################### 
# &readsettings 
####################################################

# fasta-path
#my $fastapath;
my $outputpath;
if ( $driverpath =~ m/sista/) 
{ #$fastapath = '/users/sista/vstorms/Datasets/Valerie/250_50_new/';
  $outputpath = '/users/sista/mclaeys/INCLUSive_tests/MS-250_50_new/';
}
else  
{ #$fastapath = '/home/marleen/MS-250_50_new/';
  $outputpath = '/home/marleen/MS-250_50_new/';
}

my $FClogfile = $outputpath.'FC.log';
open(FO,">$FClogfile");

# variables to be loaded from the settingsfile
my @data; #= ('LexA');
#my @space; # = ('coregulation/');
my @bgOrder; # = (0,1,2,3);
#my $bmatrix; # = 1
#my $btrack; # = 1;
my @nbrInstPrior; # = ('0.25_0.25','0.9_0.25', 'u', 'e0_1', 'e0_0_1', 'e0_0.45_0.3_0.25','f0_1');
my @search; # = (1); 
my $runs; # = 100;
my $repeats; #10
# removed from settingsfile (needed for searching MS text file as input for FC) : 
my $width = 0; #to be read from the specific inputfile wM.txt
my $nbrMotifs = 1; 
my $overlap = '-'; # not applicable 
my $strand = 0;
my $maxInst = 0; #to be read from the specific inputfile
# for FC :
my @parFCmode; #run all three modes 
# read the ARGV 
my $nbrargv = $#ARGV;
my $settingsfile = $ARGV[0];
if (!(-e $settingsfile)) { print 'ERROR '.$settingsfile." : file not found - end\n"; exit(-1);} 
# read the settings 
&readsettings($settingsfile);

# local variables
my $bOverlap;
my $wMfile;
my $inputfile;
my $matrixfile;
my $textfile;
my $prior; 
my $method;

# repeat for each dataset
for(my $d = 0; $d < scalar(@data); $d++)
{
  # get the motifwidth and maxInst (the wM.txt file should be available)
  $wMfile = $outputpath.'RegulonDB/'.$data[$d].'_wM.txt';
  if (!(-e $wMfile))
  { print 'WARNING '.$wMfile." : wMfile not found - SKIP FuzzyClustering\n"; next;}
  &readsettings($wMfile);
  if ( $width == 0 || $maxInst == 0)
  { print 'WARNING '.$wMfile.' : wrong $width/$maxInst format - SKIP FuzzyClustering'."\n"; next;} 

  # repeat for each backgroundfile
  for(my $b = 0; $b < scalar(@bgOrder); $b++)
  {
    #repeat for each nbrInstprior
    for(my $p = 0; $p < scalar(@nbrInstPrior); $p++)
    {
      $prior = $nbrInstPrior[$p];
      #repeat for each search method
      for(my $m = 0; $m < scalar(@search); $m++)
      {
        $method = $search[$m];
        if (!(-e $outputpath.'output1/'.$data[$d].'/'.'bg_'.$bgOrder[$b].'/prior_'.$prior.'/method_'.$method))
        { print 'WARNING '.$outputpath.'output1/'.$data[$d].'/'.'bg_'.$bgOrder[$b].'/prior_'.$prior.'/method_'.$method." : dir not found - SKIP FuzzyClustering\n"; next;}

        #now find the requested -f txtfile for FuzzyClustering
        for(my $r=1; $r <= $repeats; $r++)
        {

          $inputfile = $outputpath.'output1/'.$data[$d].'/'.'bg_'.$bgOrder[$b].'/prior_'.$prior.'/method_'.$method.'/'.'w'.$width.'_n'.$nbrMotifs.'_s'.$strand.'_x'.$overlap.'_M'.$maxInst.'_r'.$r.'.txt';
          if (!(-e $inputfile))
          { print FO 'WARNING '.$inputfile." : file not found - SKIP FuzzyClustering\n"; next;}

          # repeat the process for each mode = basic/sym/asym
          for(my $t = 0; $t < scalar(@parFCmode); $t++)
          {
            #create appropriate outputfiles for FuzzyClustering
            $outputfile = $inputfile; $outputfile =~ s/\.txt//; $outputfile .= '_FC_t'.$parFCmode[$t].'_i05_c025';
            $matrixfile = $inputfile; $matrixfile =~ s/\.txt//; $matrixfile .= '_FC_t'.$parFCmode[$t].'_i05_c025';
            if ($parFCmode[$t] eq 'asym'){ $outputfile .= '_j01'; $matrixfile .= '_j01';} else {$outputfile .= '_b1_p01';$matrixfile .= '_b1_p01';}
            if ($parFCmode[$t] eq 'basic'){ $outputfile .= '_m05';$matrixfile .= '_m05';}
            $outputfile .= '.txt'; $matrixfile .= '.mtrx';

            # and run the algorithm 
            $command = $driverpath.'applications/FuzzyClustering -f '.$inputfile.' -o '.$outputfile.' -O '.$matrixfile.' -t '.$parFCmode[$t].' -i 0.5 -c 0.25';
            if ($parFCmode[$t] eq 'asym'){ $command .= ' -j 0.1';} else {$command .= ' -b 1 -p 0.1';}
            if ($parFCmode[$t] eq 'basic'){ $command .= ' -m 0.5';}
            system($command);
            # report progress 
            if ($r==$repeats && $t==(scalar(@parFCmode)-1)) {print FO '# FC done for '.$data[$d].' with bg_'.$bgOrder[$b].'/prior_'.$prior.'/method_'.$method."\n";}   
          }
        }
      }
    }
  }
  print FO 'INFO @data[$d] = '.$data[$d]." - FINISHED\n";  
}
print FO 'END script finishes succesfully'."\n";  
close(FO);       
           
######################################## SUBROUTINES
######################################################################################
#loading variables from file into main
######################################################################################
sub readsettings 
{ 
  my ($file) = @_;
  open(FI, $file);
  while(<FI>) 
  {
    my $line = $_; 
    chomp $line;
    if ($line =~ m/^\$/ || $line =~ m/^\@/){ eval($line);}
  }
  close(FI);
}


